//Gui profile for the drop down list.
new GuiControlProfile(AllPrintRatios_ListProfile)
{
	tab = "0";
	canKeyFocus = "0";
	mouseOverSelected = "0";
	modal = "1";
	opaque = "1";
	fillColor = "200 200 200 255";
	fillColorHL = "180 180 180 255";
	fillColorNA = "200 200 200 255";
	border = "1";
	borderThickness = "1";
	borderColor = "69 69 69 255";
	borderColorHL = "128 128 128 255";
	borderColorNA = "64 64 64 255";
	fontType = "Arial";
	fontSize = "20";
	fontColors[0] = "69 69 69 255";
	fontColors[1] = "128 128 128 255";
	fontColors[2] = "200 200 200 255";
	fontColors[3] = "200 200 200 255";
	fontColors[4] = "0 0 204 255";
	fontColors[5] = "85 26 139 255";
	fontColors[6] = "0 0 0 0";
	fontColors[7] = "0 0 0 0";
	fontColors[8] = "0 0 0 0";
	fontColors[9] = "0 0 0 0";
	fontColor = "69 69 69 255";
	fontColorHL = "128 128 128 255";
	fontColorNA = "200 200 200 255";
	fontColorSEL = "200 200 200 255";
	fontColorLink = "0 0 204 255";
	fontColorLinkHL = "85 26 139 255";
	doFontOutline = "0";
	fontOutlineColor = "255 255 255 255";
	justify = "center";
	textOffset = "0 0";
	autoSizeWidth = "0";
	autoSizeHeight = "0";
	returnTab = "0";
	numbersOnly = "0";
	cursorColor = "0 0 0 255";
	bitmap = "base/client/ui/blockWindow";
	hasBitmapArray = "0";
};

//Replace the default gui with the drop down list one.
function PSD_Window::SetAllPrintRatiosGui(%this, %bool)
{
	if(!%this.mustUpdate && %this.AllPrintRatiosEnabled !$= "" && %this.AllPrintRatiosEnabled == %bool)
		return;

	if(%bool)
	{
		PSD_Window.clear();
		PSD_Window.add(new GuiButtonCtrl()
		{
			profile = "GuiButtonProfile";
			position = "-166 241";
			extent = "140 30";
			command = "canvas.popDialog(\"printSelectorDlg\");";
			accelerator = "escape";
		});
		PSD_Window.add(new GuiBitmapCtrl()
		{
			position = "3 44";
			extent = "209 2";
			bitmap = "base/client/ui/bar1";
		});	
		PSD_Window.add(%list = new GuiPopupMenuCtrl(AllPrintRatios_List)
		{
			profile = AllPrintRatios_ListProfile;
			position = "3 24";
			extent = "207 20";
		});
		%list.clear();
		for(%i = 0; %i < getFieldCount($AllPrintRatios_Names); %i++)
		{
			%name = getField($AllPrintRatios_Names, %i);
			%list.add(%name, %i);
			%list.idOf[%name] = %i;
			PSD_LoadPrints(%name, getField($AllPrintRatios_Starts, %i), getField($AllPrintRatios_Lengths, %i));
			%obj = nameToId(PSD_PrintScroller @ %name);
			%obj.setVisible(0);
			%obj.position = getWord(%obj.position, 0) SPC getWord(%obj.position, 1) + 4;
		}
	}
	else
	{
		PSD_Window.clear();	
		PSD_Window.add(new GuiButtonCtrl()
		{
			profile = "GuiButtonProfile";
			position = "-166 241";
			extent = "140 30";
			command = "canvas.popDialog(\"printSelectorDlg\");";
			accelerator = "escape";
			text = "exit";
		});
		PSD_Window.add(new GuiBitmapButtonCtrl()
		{
			profile = "BlockButtonProfile";
			position = "69 22";
			extent = "58 18";
			command = "PSD_LettersTab();";
			text = "Letters";
			bitmap = "base/client/ui/tab1";
		});
		PSD_Window.add(new GuiBitmapButtonCtrl()
		{
			profile = "BlockButtonProfile";
			position = "10 22";
			extent = "58 18";
			command = "PSD_PrintsTab();";
			text = "Prints";
			bitmap = "base/client/ui/tab1";
		});
		PSD_Window.add(new GuiBitmapCtrl()
		{
			position = "3 40";
			extent = "209 2";
			bitmap = "base/client/ui/bar1";
		});	
	}

	%this.mustUpdate = 0;
	%this.AllPrintRatiosEnabled = %bool;
}

//Open a tab.
function PSD_Window::ShowAllPrintRatiosTab(%this, %tab)
{
	PSD_Window.lastTabOf[$PSD_CurrentAR] = %tab;
	if(isObject(%obj = nameToId(PSD_PrintScroller @ $PSD_CurrentARPage)))
		%obj.setVisible(0);

	nameToId(PSD_PrintScroller @ %tab).setVisible(1);

	Canvas.pushDialog(printSelectorDlg);
	$PSD_CurrentARPage = %tab;
}

//Select a tab.
function AllPrintRatios_List::onSelect(%this, %val)
{
	PSD_Window.ShowAllPrintRatiosTab(%this.getTextByID(%val));
}

package AllPrintRatios_Client
{
	//Open the print selector on the correct tab if the server is running AllPrintRatios.
	//Do the default action if it isn't.
	function clientCmdOpenPrintSelectorDlg(%aspectRatio, %startPrint, %numPrints)
	{
		if(!$ServerHasAllPrintRatios)
		{
			parent::clientCmdOpenPrintSelectorDlg(%aspectRatio, %startPrint, %numPrints);
		}
		else
		{
			PSD_Window.SetAllPrintRatiosGui(1);
			$PSD_CurrentAR = %aspectRatio;
			if(isObject(nameToId("PSD_PrintScroller" @ PSD_Window.lastTabOf[%aspectRatio])))
				%aspectRatio = PSD_Window.lastTabOf[%aspectRatio];
			else
				%aspectRatio = "All Prints";			
			AllPrintRatios_List.setSelected(AllPrintRatios_List.idOf[%aspectRatio]);
			PSD_Window.ShowAllPrintRatiosTab(%aspectRatio);
		}
	}

	//New server, assume it does not have AllPrintRatios enabled
	function GameConnection::onConnectionAccepted(%this)
	{
		PSD_Window.mustUpdate = 1;
		PSD_Window.SetAllPrintRatiosGui(0);
		$ServerHasAllPrintRatios = 0;
		return parent::onConnectionAccepted(%this);
	}

	//Receive info about the available aspect ratios.
	//If we do not receive this command, the server is not running AllPrintRatios, and we don't enable the change to the gui.
	function clientCmdSetPrintRatioTable(%names, %starts, %lengths)
	{
		$ServerHasAllPrintRatios = 1;
		PSD_Window.mustUpdate = 1;
		$AllPrintRatios_Names = %names;
		$AllPrintRatios_Starts = %starts;
		$AllPrintRatios_Lengths = %lengths;
	}
};
activatePackage(AllPrintRatios_Client);