package AllPrintRatios_Server
{
	//Tell the client additional info about the print ratios, to display a drop down list in the gui.
	function sendLetterPrintInfo(%client)
	{
		parent::sendLetterPrintInfo(%client);
		%names = "All Prints" TAB $AllPrintRatios_ARList;

		%starts = $printARNumPrints["Letters"];
		%lengths = $globalPrintCount - $printARNumPrints["Letters"];
		for(%i = 0; %i < getFieldCount(%names); %i++)
		{
			%starts = %starts TAB $printARStart[getField($AllPrintRatios_ARList, %i)];
			%lengths = %lengths TAB $printARNumPrints[getField($AllPrintRatios_ARList, %i)];
		}

		commandToClient(%client, 'SetPrintRatioTable', %names, %starts, %lengths);
	}

	//This is going to send the command to open the GUI 2 times but that doesn't matter.
	//AllPrintRatios will open the correct tab based on the %ar value.
	//The other 2 values cause clients not running AllPrintRatios to see all prints at once, not fancy, but the only solution.
	function PrintGunImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
	{
		parent::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal);
		commandToClient(%client, 'openPrintSelectorDlg', %ar, $printARNumPrints["Letters"], $globalPrintCount - $printARNumPrints["Letters"]);
	}


	//Allow setting prints with other aspect ratios as the brick.
	function serverCmdSetPrint(%client, %index)
	{
		%printBrick = getWord(%client.printBrick, 0);
		if(isObject(%printBrick))
			%oldPrintID = %printBrick.getPrintID();
		else
			%oldPrintID = -1;

		parent::serverCmdSetPrint(%client, %index);

		if(isObject(%printBrick))
		{
			if(%printBrick.getPrintID() == %oldPrintID)
			{
				if(%printBrick.getPrintID() != %index)
				{
					%client.undoStack.push(%printBrick TAB "PRINT" TAB %printBrick.getPrintID());
					%printBrick.setPrint(%index);
					%client.lastPrint[%printBrick.getDataBlock().printAspectRatio] = %index;

					%player = %client.player;
					if(isObject(%player))
						if(isObject(%player.tempBrick))
							if(%player.tempBrick.getDataBlock().printAspectRatio !$= "")
								%player.tempBrick.setPrint(%index);	
				}
			}
		}
	}

	//Load the letters first, then all the other prints (GameMode verson).
	//Then we can have it display all prints except letters for clients who don't have AllPrintRatios.
	function loadGameModePrintedBrickTextures()
	{
		deleteVariables("$printNameTable*");
		deleteVariables("$printARNumPrints*");
		deleteVariables("$printARStart*");
		deleteVariables("$printAREnd*");
		
		$globalPrintCount = 0;
		%localPrintCount = 0;

//original:
/////////////////////////////////////////////////////////////////////////////////////////////////
//		for(%i = 0; %i < $GameMode::AddOnCount; %i++)
//		{
//			if(!strnicmp($GameMode::AddOn[%i], "Print_", strlen("Print_")))
//			{
//				echo("PRINT" SPC $GameMode::AddOn[%i]);
//				%start = strlen("Print_");
//				%end = stripos($GameMode::AddOn[%i], "_", %start + 1);
//				%loadingAR = getSubStr($GameMode::AddOn[%i], %start, %end - %start);
//
//				if(!%arLoaded[%loadingAR])
//				{
//					$printARStart[%loadingAR] = $globalPrintCount;
//					%localPrintCount = 0;
//					for(%j = %i; %j < $GameMode::AddOnCount; %j++)
/////////////////////////////////////////////////////////////////////////////////////////////////

//edited:
/////////////////////////////////////////////////////////////////////////////////////////////////
		$AllPrintRatios_ARList = "Letters";
		for(%i = 0; %i < $GameMode::AddOnCount; %i++)
		{
			if(!strnicmp($GameMode::AddOn[%i], "Print_", strlen("Print_")))
			{
				%start = strlen("Print_");
				%end = stripos($GameMode::AddOn[%i], "_", %start + 1);
				%testAR = getSubStr($GameMode::AddOn[%i], %start, %end - %start);

				for(%j = 0; %j < getFieldCount($AllPrintRatios_ARList); %j++)
					if(getField($AllPrintRatios_ARList, %j) $= %testAR)
						%found = 1;

				if(!%found)
					$AllPrintRatios_ARList = $AllPrintRatios_ARList TAB %testAR;
			}
		}
		for(%i = 0; %i < getFieldCount($AllPrintRatios_ARList); %i++)
		{
					%loadingAR = getField($AllPrintRatios_ARList, %i);

					$printARStart[%loadingAR] = $globalPrintCount;
					%localPrintCount = 0;
					for(%j = 0; %j < $GameMode::AddOnCount; %j++)
/////////////////////////////////////////////////////////////////////////////////////////////////
					{				
						if(!strnicmp($GameMode::AddOn[%j], "Print_", strlen("Print_")))
						{
							%start = strlen("Print_");
							%end = stripos($GameMode::AddOn[%j], "_", %start + 1);
							%testAR = getSubStr($GameMode::AddOn[%j], %start, %end - %start);
							if(%testAR $= %loadingAR)
							{
								echo("Loading " @ $GameMode::AddOn[%j]);
								%pattern = "Add-Ons/" @ $GameMode::AddOn[%j] @ "/prints/*.png";
								for(%filename = findFirstFile(%pattern); %filename !$= ""; %filename = findNextFile(%pattern))
								{
									%fileBase = fileBase(%filename);
									%iconFileName = "Add-Ons/" @ $GameMode::AddOn[%j] @ "/icons/" @ %fileBase @ ".png";
									if(strPos(%fileBase, " ") != -1)
										warn("WARNING: loadGameModePrintedBrickTextures() - Bad print file name \"" @ %filename @ "\" - Cannot have spaces");
									else
									{
										if(!isFile(%iconFileName))
											warn("WARNING: loadGameModePrintedBrickTextures() - Print \"" @ %filename @ "\" has no icon - skipping");
										else
										{
											%idString = %loadingAR @ "/" @ %fileBase;
											if($printNameTable[%idString] !$= "")
												warn("WARNING: loadGameModePrintedBrickTextures() - Print \"" @ %filename @ "\" - " @ %idString @ " already exists - skipping");
											else
											{
												$printNameTable[%idString] = $globalPrintCount;
												setPrintTexture($globalPrintCount, %filename);
												$globalPrintCount++;
												%localPrintCount++;
											}
										}
									}
								}
							}
						}
					}
					$printARNumPrints[%loadingAR] = %localPrintCount;
					%arLoaded[%loadingAR] = 1;
					$printAREnd[%loadingAR] = $globalPrintCount;
//original:
/////////////////////////////////////////////////////////////////////////////////////////////////
//				}
//			}
/////////////////////////////////////////////////////////////////////////////////////////////////
		}
	}

	//Load the letters first, then the other prints (Custom Game Version).	
	//Then we can have it display all prints except letters for clients who don't have AllPrintRatios.
	function loadPrintedBrickTextures()
	{
//edited:
/////////////////////////////////////////////////////////////////////////////////////////////////
		%arList = "Letters";
/////////////////////////////////////////////////////////////////////////////////////////////////
		%count = DataBlockGroup.getCount();

		for(%i = 0; %i < %count; %i++)
		{
			%db = DataBlockGroup.getObject(%i);
			if(%db.getClassName() $= "fxDTSBrickData")
			{
				%newAR = %db.printAspectRatio;
				if(%newAR !$= "")
				{
					if(strPos(%newAR, " ") != -1)
						warn("WARNING: loadPrintedBrickTextures() - Bad aspect ratio name \"" @ %newAR @ "\" on " @ %db.getName() @ " - Cannot have spaces");
					else if(strPos(%newAR, "/") != -1)
						warn("WARNING: loadPrintedBrickTextures() - Bad aspect ratio name \"" @ %newAR @ "\" on " @ %db.getName() @ " - Cannot have /'s");
					else if(strPos(%newAR, "\"") != -1)
						warn("WARNING: loadPrintedBrickTextures() - Bad aspect ratio name \"" @ %newAR @ "\" on " @ %db.getName() @ " - Cannot have \"'s");
					else
					{
						%arCount = getFieldCount(%arList);
						%addToList = 1;

						for(%j = 0; %j < %arCount; %j++)
						{
							%field = getField(%arList, %j);
							if(%field $= %newAR)
								%addToList = 0;
						}
						if(%addToList)
						{
							if(%arList $= "")
								%arList = %newAR;
							else
								%arList = %arList TAB %newAR;
						}
					}
				}
			}
		}

		deleteVariables("$printNameTable*");
		$globalPrintCount = 0;
		%fieldCount = getFieldCount(%arList);

		for(%i = 0; %i < %fieldCount; %i++)
		{
			%field = getField(%arList, %i);
			loadPrintedBrickTexture(%field);		
		}
//original:
/////////////////////////////////////////////////////////////////////////////////////////////////
//		loadPrintedBrickTexture("Letters");
/////////////////////////////////////////////////////////////////////////////////////////////////

//edited:
/////////////////////////////////////////////////////////////////////////////////////////////////
		$AllPrintRatios_ARList = %arList;
/////////////////////////////////////////////////////////////////////////////////////////////////
	}

	//By default the loading function prevents us from setting prints of 'wrong' aspect ratios.
	//We can't just rewrite ServerLoadSaveFile_Tick because
	// -it is huge and would take forever to convert to torkscript
	// -loads of add-ons depend on it

	//That means we have to create a second FileObject to read the save file again, and set the prints.
	//This is a hacky solution and I am in no way happy with it, but it works so who cares.
	function ServerLoadSaveFile_Tick()
	{
		parent::ServerLoadSaveFile_Tick();
		
		if(isObject($AllPrintRatios_SaveFileRead))
		{
			%line = $AllPrintRatios_SaveFileRead.readLine();
			%brick = $LastLoadedBrick;
			//A new brick was created if it is different from the last one
			if(%brick !$= $AllPrintRatios_LastBrick && isObject(%brick))
			{
				//end of uiname
				if((%pos = strPos(%line, "\"")) > -1)
				{
					%pos += 2;
					%line = getSubStr(%line, %pos, strLen(%line) - %pos);

					//6th word is print id
					if(getWordCount(%line) > 6)
					{
						%print = getWord(%line, 6);
						%pid = $printNameTable[%print];

						//check is print exists and if brick is a print brick
						if(%pid !$= "" && %brick.getPrintID() != %pid && %brick.getDataBlock().printAspectRatio !$= "")
							%brick.setPrint(%pid);
					}
				}
			}
			$AllPrintRatios_LastBrick = %brick;
		}
	}

	function ServerLoadSaveFile_End()
	{
		parent::ServerLoadSaveFile_End();

		if(isObject($AllPrintRatios_SaveFileRead))
		{
			$AllPrintRatios_SaveFileRead.close();
			$AllPrintRatios_SaveFileRead.delete();
		}
	}

	function ServerLoadSaveFile_Start(%filename)
	{
		if(!isFile(%filename))
			%filename = "base/server/temp/temp.bls";

		if(!$Game::MissionCleaningUp && isFile(%filename))
		{
			if(isObject($AllPrintRatios_SaveFileRead))
			{
				$AllPrintRatios_SaveFileRead.close();
				$AllPrintRatios_SaveFileRead.delete();
			}

			$AllPrintRatios_SaveFileRead = new FileObject();
			$AllPrintRatios_SaveFileRead.openForRead(%filename);

			$AllPrintRatios_SaveFileRead.readLine();
			%descLength = $AllPrintRatios_SaveFileRead.readLine();

			for(%i = 0; %i < %descLength + 64; %i++)
				$AllPrintRatios_SaveFileRead.readLine();
		}

		parent::ServerLoadSaveFile_Start(%filename);
	}
};
activatePackage(AllPrintRatios_Server);
